#!/bin/bash

set -e

SNAP_ID="rootfs"
SNAP_ORIG_PATH="/"

############################# function
remove_overlay() {
        if test -e "$SNAP_ORIG_PATH/.overlay_$SNAP_ID"
        then
                LODEV=`losetup -j "$SNAP_ORIG_PATH/.overlay_$SNAP_ID" | cut -d':' -f1`
                if [ "x$LODEV" != x ]
                then
                        losetup -d $LODEV
                fi
                rm "$SNAP_ORIG_PATH/.overlay_$SNAP_ID"
        fi
}

#############################

SNAP_MOUNTPOINT="/mnt/urbackup_snaps/$SNAP_ID"

NUM=`cat "${SNAP_MOUNTPOINT}-num"` || true

if [ "x$NUM" = "x" ]
then
    echo "Please fix it manually"
    exit 1
fi

echo "Unmounting /dev/datto$NUM at /mnt/urbackup_snaps/$SNAP_ID..."

if ! umount /mnt/urbackup_snaps/$SNAP_ID
then
    lsof /mnt/urbackup_snaps/$SNAP_ID || true
    echo "Unmounting /mnt/urbackup_snaps/$SNAP_ID failed. Retrying in 10s..."
    sleep 10
    umount /mnt/urbackup_snaps/$SNAP_ID
fi

rm "${SNAP_MOUNTPOINT}-num"
rmdir "${SNAP_MOUNTPOINT}"

#############################

echo "Removing devicemapper snapshot ..."

dmsetup remove "wsnap-$SNAP_ID"

#############################

remove_overlay

#############################

echo "Destroying dattobd snapshot /dev/datto$NUM..."

dbdctl destroy $NUM

[ ! -e "$SNAP_ORIG_PATH/.datto_$SNAP_ID" ] || rm "$SNAP_ORIG_PATH/.datto_$SNAP_ID"

#############################

exit 0
